HDU 1130 How Many Trees卡特兰数

来源:互联网 发布:电脑室控制软件 编辑:程序博客网 时间:2024/05/23 14:22

How Many Trees?

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 3943    Accepted Submission(s): 2232


Problem Description
A binary search tree is a binary tree with root k such that any node v reachable from its left has label (v) <label (k) and any node w reachable from its right has label (w) > label (k). It is a search structure which can find a node with label x in O(n log n) average time, where n is the size of the tree (number of vertices). 

Given a number n, can you tell how many different binary search trees may be constructed with a set of numbers of size n such that each element of the set will be associated to the label of exactly one node in a binary search tree? 
 

Input
The input will contain a number 1 <= i <= 100 per line representing the number of elements of the set.
 

Output
You have to print a line in the output for each entry with the answer to the previous question.
 

Sample Input
123
 

Sample Output
125
 

解题思路:
本题的意思是求:含有n个结点的二叉搜索树的个数。
为Catalan数的经典应用之一。
由于本题的范围为1 <= i <= 100 ,因此应使用大数处理,即使用递推公式a(n)=a(n-1)*(4*n-2)/(n+1)。



#include<iostream>#include<cstring>using namespace std;#define maxn 110#define base 10000void multiply(int a[],int b){//大数乘法    int i,temp=0;    for(i=maxn-1;i>=0;i--){        temp+=b*a[i];        a[i]=temp%base;        temp/=base;    }}void divide(int a[],int b){//大数除法    int i,temp=0;    for(i=0;i<maxn;i++){        temp=temp*base+a[i];        a[i]=temp/b;        temp%=b;    }}int main(){    int a[maxn][maxn],i,n;    memset(a,0,sizeof(a));    for(i=2,a[1][maxn-1]=1;i<maxn;i++){//高坐标存放大数低位        memcpy(a[i],a[i-1],maxn*sizeof(int));        multiply(a[i],4*i-2);        divide(a[i],i+1);    }    while(cin>>n){        for(i=0;i<maxn&&a[n][i]==0;i++);        cout<<a[n][i++];        for(;i<maxn;i++){            printf("%04d",a[n][i]);        }        cout<<endl;    }    return 0;}



有关于卡特兰数的大数处理,经各种百度。。。。。。有两种方法(其实也都差不多),可以参考http://blog.163.com/lz_666888/blog/static/1147857262009914112922803/
(在前人的经验下整理如下)<捂脸>:

方法一:

#include<iostream>

#include<cmath>

#include<cstring>

using namespace std;

#define maxn 110

int a[maxn][maxn];//a[maxn][maxn]用来大数处理

int b[maxn];//b[maxn]用来存储位数

void catalan(){//第一种,也就是本题的AC代码

    int i,j,len,carry,temp;//carry处理进位,temp用来暂时存储进位的数+原数

    a[1][0]=b[1]=1;

    len=1;

    for(i=2;i<=100;i++){

        for(j=0;j<=len;j++)

            a[i][j]=a[i-1][j]*(4*(i-1)+2);

        carry=0;

        for(j=0;j<len;j++){

            temp=a[i][j]+carry;

            a[i][j]=temp%10;

            carry=temp/10;

        }

        while(carry){

            a[i][len++]=carry%10;

            carry/=10;

        }

        carry=0;

        for(j=len-1;j>=0;j--){

            temp=a[i][j]+carry*10;

            a[i][j]=temp/(i+1);

            carry=temp%(i+1);

        }

        while(!a[i][len-1])

            len--;

        b[i]=len;

    }

}

int main(){

    catalan();

    int i,n;

    while(cin>>n){

        for(i=b[n]-1;i>=0;i--)

            cout<<a[n][i];

        cout<<endl;

    }

return0;

}


方法二:

#include<iostream>

#include<cstring>

using namespace std;

#define maxn 110

#define base 10000

void multiply(int a[],int b){//大数乘法

    int i,temp=0;

    for(i=maxn-1;i>=0;i--){

        temp+=b*a[i];

        a[i]=temp%base;

        temp/=base;

    }

}

void divide(int a[],int b){//大数除法

    int i,temp=0;

    for(i=0;i<maxn;i++){

        temp=temp*base+a[i];

        a[i]=temp/b;

        temp%=b;

    }

}

int main(){

    int a[maxn][maxn],i,n;

    memset(a,0,sizeof(a));

    for(i=2,a[1][maxn-1]=1;i<maxn;i++){//高坐标存放大数低位

        memcpy(a[i],a[i-1],maxn*sizeof(int));

        multiply(a[i],4*i-2);

        divide(a[i],i+1);

    }

    while(cin>>n){

        for(i=0;i<maxn&&a[n][i]==0;i++);

        cout<<a[n][i++];

        for(;i<maxn;i++){

            printf("%04d",a[n][i]);

        }

        cout<<endl;

    }

return 0;

}


类似的题目:HDU 1134、HDU 1023

阅读全文
0 0
原创粉丝点击